pangomm: Pango::FontFamily Class Reference

pangomm 2.46.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Pango::FontFamily Class Reference

A Pango::FontFamily is used to represent a family of related font faces. More...

`#include <pangomm/fontfamily.h>`

Inheritance diagram for Pango::FontFamily:
[legend]

## Public Member Functions
| FontFamily (FontFamily&& src) noexcept
FontFamily& | operator= (FontFamily&& src) noexcept
| ~FontFamily () noexcept override
PangoFontFamily* | gobj ()
| Provides access to the underlying C GObject. More...
const PangoFontFamily* | gobj () const
| Provides access to the underlying C GObject. More...
PangoFontFamily* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ArrayHandle< Glib::RefPtr< FontFace > > | list_faces () const
| Lists the different font faces that make up family. More...
Glib::ustring | get_name () const
| Gets the name of the family. More...
bool | is_monospace () const
| A monospace font is a font designed for text display where the the characters form a regular grid. More...
bool | is_variable () const
| A variable font is a font which has axes that can be modified to produce different faces. More...
Glib::RefPtr< FontFace > | get_face (const Glib::ustring& name={})
| Gets the Pango::FontFace of family with the given name. More...
Glib::RefPtr< const FontFace > | get_face (const Glib::ustring& name={}) const
| Gets the Pango::FontFace of family with the given name. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Pango::FontFamily > | wrap (PangoFontFamily* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

A Pango::FontFamily is used to represent a family of related font faces.

The faces in a family share a common design, but differ in slant, weight, width and other aspects.

## Constructor & Destructor Documentation

## ◆ FontFamily()

Pango::FontFamily::FontFamily | ( | FontFamily&& | src | ) |
| noexcept

## ◆ ~FontFamily()

Pango::FontFamily::~FontFamily | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ get_face() [1/2]

Glib::RefPtr<FontFace> Pango::FontFamily::get_face | ( | const Glib::ustring & | name = `{}` | ) |

Gets the Pango::FontFace of family with the given name.

Since pangomm 1.46:

Parameters

  name | The name of a face. If the name is `nullptr`, the family's default face (fontconfig calls it "Regular") will be returned.

Returns
  The Pango::FontFace, or `nullptr` if no face with the given name exists.

## ◆ get_face() [2/2]

Glib::RefPtr<const FontFace> Pango::FontFamily::get_face | ( | const Glib::ustring & | name = `{}` | ) | const

Gets the Pango::FontFace of family with the given name.

Since pangomm 1.46:

Parameters

  name | The name of a face. If the name is `nullptr`, the family's default face (fontconfig calls it "Regular") will be returned.

Returns
  The Pango::FontFace, or `nullptr` if no face with the given name exists.

## ◆ get_name()

Glib::ustring Pango::FontFamily::get_name | ( |  | ) | const

Gets the name of the family.

The name is unique among all fonts for the font backend and can be used in a Pango::FontDescription to specify that a face from this family is desired.

Returns
  The name of the family. This string is owned by the family object and must not be modified or freed.

## ◆ get_type()

static GType Pango::FontFamily::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

PangoFontFamily* Pango::FontFamily::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const PangoFontFamily* Pango::FontFamily::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

PangoFontFamily* Pango::FontFamily::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_monospace()

bool Pango::FontFamily::is_monospace | ( |  | ) | const

A monospace font is a font designed for text display where the the characters form a regular grid.

For Western languages this would mean that the advance width of all characters are the same, but this categorization also includes Asian fonts which include double-width characters: characters that occupy two grid cells. Glib::unichar_iswide() returns a result that indicates whether a character is typically double-width in a monospace font.

The best way to find out the grid-cell size is to call Pango::FontMetrics::get_approximate_digit_width(), since the results of Pango::FontMetrics::get_approximate_char_width() may be affected by double-width characters.

Since pangomm 1.4:

Returns
  `true` if the family is monospace.

## ◆ is_variable()

bool Pango::FontFamily::is_variable | ( |  | ) | const

A variable font is a font which has axes that can be modified to produce different faces.

Since pangomm 1.44:

Returns
  `true` if the family is variable.

## ◆ list_faces()

Glib::ArrayHandle< Glib::RefPtr<FontFace> > Pango::FontFamily::list_faces | ( |  | ) | const

Lists the different font faces that make up family.

The faces in a family share a common design, but differ in slant, weight, width and other aspects.

Returns
  an array of pointers to Pango::FontFace objects.

## ◆ operator=()

FontFamily& Pango::FontFamily::operator= | ( | FontFamily&& | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Pango::FontFamily > wrap | ( | PangoFontFamily * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.